/*
*********************************************************************************************************
*                                     DJI BOARD SUPPORT PACKAGE
*
*                                   (c) Copyright 2015; Dji, Inc.
*
*               All rights reserved.  Protected by international copyright laws.
*               Knowledge of the source code may NOT be used to develop a similar product.
*               Please help us continue to provide the Embedded community with the finest
*               software available.  Your honesty is greatly appreciated.
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                           INFANTRY_CONTROL_BOARD_V2
*
* Filename      : bsp_flash.h
* Version       : V0.10
* Programmer(s) : SC.H
*********************************************************************************************************
*/
#ifndef __BSP_FLASH_H
#define __BSP_FLASH_H


/*
*********************************************************************************************************
*                                             INCLUDE FILES
*********************************************************************************************************
*/

#include "stm32f4xx.h" 


/*
*********************************************************************************************************
*                                             FLASHַ
*********************************************************************************************************
*/

//FLASHʼַ
#define STM32_FLASH_BASE 0x08000000 	//STM32 FLASHʼַ
 

//FLASH ʼַ
#define ADDR_FLASH_SECTOR_0     ((u32)0x08000000) 	//0ʼַ, 16 Kbytes  
#define ADDR_FLASH_SECTOR_1     ((u32)0x08004000) 	//1ʼַ, 16 Kbytes  
#define ADDR_FLASH_SECTOR_2     ((u32)0x08008000) 	//2ʼַ, 16 Kbytes  
#define ADDR_FLASH_SECTOR_3     ((u32)0x0800C000) 	//3ʼַ, 16 Kbytes  
#define ADDR_FLASH_SECTOR_4     ((u32)0x08010000) 	//4ʼַ, 64 Kbytes  
#define ADDR_FLASH_SECTOR_5     ((u32)0x08020000) 	//5ʼַ, 128 Kbytes  
#define ADDR_FLASH_SECTOR_6     ((u32)0x08040000) 	//6ʼַ, 128 Kbytes  
#define ADDR_FLASH_SECTOR_7     ((u32)0x08060000) 	//7ʼַ, 128 Kbytes  
#define ADDR_FLASH_SECTOR_8     ((u32)0x08080000) 	//8ʼַ, 128 Kbytes  
#define ADDR_FLASH_SECTOR_9     ((u32)0x080A0000) 	//9ʼַ, 128 Kbytes  
#define ADDR_FLASH_SECTOR_10    ((u32)0x080C0000) 	//10ʼַ,128 Kbytes  
#define ADDR_FLASH_SECTOR_11    ((u32)0x080E0000) 	//11ʼַ,128 Kbytes  

/*
*********************************************************************************************************
*                                             ӿ
*********************************************************************************************************
*/
u8 BSP_FLASH_Write(u32 WriteAddr, u8 *pBuffer, u32 NumToWrite);		    //ַָʼдָȵ
void BSP_FLASH_Read(u32 ReadAddr, u8 *pBuffer, u32 NumToRead);   		//ַָʼָȵ

#endif


